# TmModifierType | pokemon-rogue-battle
Documentation for pokemon-rogue-battle

# Class TmModifierType

#### Hierarchy (View Summary)

- PokemonModifierType
  - TmModifierType

- Defined in src/modifier/modifier-type.ts:1164

##### Index

### Constructors

constructor

### Properties

group
iconImage
id
localeKey
moveId
newModifierFunc
selectFilter
soundName
tier

### Accessors

name

### Methods

getDescription
getOrInferTier
newModifier
setTier
withIdFromFunc
withTierFromPool

## Constructors

### constructor

- new TmModifierType(moveId: Moves ): TmModifierType

  #### Parameters

  - moveId: Moves

  #### Returns TmModifierType

  Overrides PokemonModifierType.constructor

  - Defined in src/modifier/modifier-type.ts:1167

## Properties

### group

group: string

Inherited from PokemonModifierType.group

- Defined in src/modifier/modifier-type.ts:149

### iconImage

iconImage: string

Inherited from PokemonModifierType.iconImage

- Defined in src/modifier/modifier-type.ts:148

### id

id: string

Inherited from PokemonModifierType.id

- Defined in src/modifier/modifier-type.ts:146

### localeKey

localeKey: string

Inherited from PokemonModifierType.localeKey

- Defined in src/modifier/modifier-type.ts:147

### moveId

moveId: Moves

- Defined in src/modifier/modifier-type.ts:1165

### `Protected` newModifierFunc

newModifierFunc: null | NewModifierFunc

Inherited from PokemonModifierType.newModifierFunc

- Defined in src/modifier/modifier-type.ts:152

### selectFilter

selectFilter: undefined | PokemonSelectFilter

Inherited from PokemonModifierType.selectFilter

- Defined in src/modifier/modifier-type.ts:364

### soundName

soundName: string

Inherited from PokemonModifierType.soundName

- Defined in src/modifier/modifier-type.ts:150

### tier

tier: ModifierTier

Inherited from PokemonModifierType.tier

- Defined in src/modifier/modifier-type.ts:151

## Accessors

### name

- get name(): string

  #### Returns string

  Overrides PokemonModifierType.name

  - Defined in src/modifier/modifier-type.ts:1187

## Methods

### getDescription

- getDescription(): string

  #### Returns string

  Overrides PokemonModifierType.getDescription

  - Defined in src/modifier/modifier-type.ts:1194

### getOrInferTier

- getOrInferTier(poolType?: ModifierPoolType ): null | ModifierTier

  #### Parameters

  - poolType: ModifierPoolType = ModifierPoolType.PLAYER

  #### Returns null | ModifierTier

  Inherited from PokemonModifierType.getOrInferTier

  - Defined in src/modifier/modifier-type.ts:180

### newModifier

- newModifier(...args: any[]): null | Modifier

  #### Parameters

  - ...args: any[]

  #### Returns null | Modifier

  Inherited from PokemonModifierType.newModifier

  - Defined in src/modifier/modifier-type.ts:273

### setTier

- setTier(tier: ModifierTier ): void

  #### Parameters

  - tier: ModifierTier

  #### Returns void

  Inherited from PokemonModifierType.setTier

  - Defined in src/modifier/modifier-type.ts:176

### withIdFromFunc

- withIdFromFunc(func: ModifierTypeFunc ): ModifierType

  Populates item id for ModifierType instance

  #### Parameters

  - func: ModifierTypeFunc

  #### Returns ModifierType

  Inherited from PokemonModifierType.withIdFromFunc

  - Defined in src/modifier/modifier-type.ts:221

### withTierFromPool

- withTierFromPool(
  poolType?: ModifierPoolType ,
  party?: PlayerPokemon [],
  rerollCount?: number,
  ): ModifierType

  Populates item tier for ModifierType instance Tier is a necessary field for items that appear in player shop (determines the Pokeball visual they use) To find the tier, this function performs a reverse lookup of the item type in modifier pools It checks the weight of the item and will use the first tier for which the weight is greater than 0 This is to allow items to be in multiple item pools depending on the conditions, for example for events If all tiers have a weight of 0 for the item, the first tier where the item was found is used

  #### Parameters

  - poolType: ModifierPoolType = ModifierPoolType.PLAYER

    Default 'ModifierPoolType.PLAYER'. Which pool to lookup item tier from

  - `Optional` party: PlayerPokemon []

    optional. Needed to check the weight of modifiers with conditional weight (see WeightedModifierTypeWeightFunc) if not provided or empty, the weight check will be ignored

  - rerollCount: number = 0

    Default `0`. Used to check the weight of modifiers with conditional weight (see WeightedModifierTypeWeightFunc)

  #### Returns ModifierType

  Inherited from PokemonModifierType.withTierFromPool

  - Defined in src/modifier/modifier-type.ts:238